         title    Convert

         .586
         .model   flat, STDCALL

         option   casemap: none   ; case sensitive
         include  FileMan.inc

.data
HoldT        dd      0

cdt     DATETIME    <>

;------------------------------------------------------------------------------------------------------------
.code

;=========================================================================|
;  Converts a 32 bit num value to a Dec, Hex, Oct or Bin ascii string.    |
;=========================================================================|
;INVOKE     BaseAscii, cnt, addr num, 2, 10, 0, 1, 0
;InPut, OutPut, Length only needed if fill is on, Base, Insert commas, Left fill, Add terminating null
BaseAscii PROC InPut:DWORD, OutPut:DWORD, LEN:DWORD, Base:DWORD, Comma:DWORD, Fill:DWORD, TermA:DWORD
LOCAL    LBuff[32]: BYTE
      pushad
         xor     esi, esi
         mov     eax, InPut                ; Input
         mov     ebx, OutPut
         mov     byte ptr [ebx], '0'
      .while (eax)
            xor     edx, edx
            div     Base                   ; Base 10, 16, 8, 2
         .if dl > 9h
               add     dl, 37h             ; Convert to hex ASCII
         .else
               add     dl, 30h             ; Convert to dec ASCII
         .endif
            mov     LBuff[esi], dl
            inc     esi
         .if Comma == 1 && Base == 10 && eax > 0
            .if esi == 3 || esi == 7 || esi == 11
                  mov     LBuff[esi], 2ch  ; Insert commas
                  inc     esi
            .endif
         .endif
      .endw
         xor     edi, edi
         mov     ecx, esi
      .if LEN > ecx && Fill == 1           ; Zero fill
            xor     eax, eax
         .while (eax < LEN)
               mov     byte ptr [ebx+eax], '0'
               inc     eax
         .endw
            sub     LEN, ecx
            add     edi, LEN
      .endif
      .while (ecx)
            mov     al, byte ptr LBuff[esi-1]
            mov     byte ptr [ebx+edi], al
            inc     edi
            dec     esi
            dec     ecx
      .endw
      .if TermA                            ; Insert a terminating char
         mov     byte ptr [ebx+edi], 0h
      .endif
       popad
          RET
BaseAscii ENDP

;========================================================================|
; Converts a Dec, Hex, Oct or Bin ascii string to a 32 bit num value.    |
;========================================================================|
;INVOKE     AsciiBase, addr Conv, addr w1, 10
AsciiBase PROC Input:DWORD, Output:DWORD, Base: DWORD
      pushad
         mov     esi, Input
         mov     edi, Output
mov     dword ptr[edi], 0
      INVOKE     lstrlen, Input
         xor     ecx, ecx
      .while (eax)
         .if byte ptr[esi+ecx] > 60h
               sub     byte ptr[esi+ecx], 57h
         .elseif byte ptr[esi+ecx] > 40h
               sub     byte ptr[esi+ecx], 37h
         .else
               xor     byte ptr[esi+ecx], 30h
         .endif
            dec     eax
            inc     ecx
      .endw
         mov     ebx, 1
         mov     esi, Input
         add     esi, ecx
         dec     esi
         xor     edx, edx
      .while (ecx)
            mov     al, byte ptr[esi]            ; Extract byte for conversion
            and     eax, 000000ffh
           imul     eax, ebx
            add     dword ptr[edi], eax          ; Accumulate output
           imul     ebx, Base
            dec     esi
            dec     ecx 
      .endw
       popad
          RET
AsciiBase ENDP

;=========================================================================|
;*  Format the time and send it to the ConvDateTime structure             |
;=========================================================================|
fmtime   PROC    time:SYSTEMTIME
       MOVmw     HoldT, time.wDay
      INVOKE     BaseAscii, HoldT, addr cdt.dda, 2, 10, 0, 1, 0
       MOVmw     HoldT, time.wMonth
      INVOKE     BaseAscii, HoldT, addr cdt.dmo, 2, 10, 0, 1, 0
       MOVmw     HoldT, time.wYear
      INVOKE     BaseAscii, HoldT, addr cdt.dyr, 4, 10, 0, 1, 0
       MOVmw     HoldT, time.wHour
      .if HoldT > 4
            sub     HoldT, 5
           push     HoldT
      .else
            add     HoldT, 20
         .if HoldT == 24
               sub     HoldT, 1
         .endif
           push     HoldT
          MOVmw     HoldT, time.wDay
            sub     HoldT, 1
         INVOKE     BaseAscii, HoldT, addr cdt.dda, 2, 10, 0, 1, 0
      .endif
         pop     HoldT   
      INVOKE     BaseAscii, HoldT, addr cdt.dhour, 2, 10, 0, 1, 0
       MOVmw     HoldT, time.wMinute
      INVOKE     BaseAscii, HoldT, addr cdt.dmin, 2, 10, 0, 1, 0
       MOVmw     HoldT, time.wSecond
      INVOKE     BaseAscii, HoldT, addr cdt.dsec, 2, 10, 0, 1, 0
         lea     eax, cdt.dmo
         RET
fmtime   ENDP
END