         title    TreeView

         .586
         .model   flat, STDCALL

         option   casemap: none   ; case sensitive
         include  FileMan.inc

TBSep    MACRO hTool
           mov     tbb.iBitmap, 0
           mov     tbb.idCommand, 0
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_SEP
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

TBButt   MACRO hTool, bID, cID, Text
           mov     tbb.iBitmap, bID    ; Button image number
           mov     tbb.idCommand, cID  ; Command ID number
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_BUTTON
           mov     tbb.dwData, 0
           mov     tbb.iString, Text
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

;------------------------------------------------------------------------------------------------------------
.const                                           ; constant data segment
szTreeClassName   db    'SysTreeView32',0
FontName1         db    'Arial Narrow',0
szRootPath        db    'C:\',0
szBackSL          db    '\',0
Comma             db    ',',0
szBL              db    '[',0
szBR              db    ']  ',0
szOf              db    ' of ',0
szKFree           db    ' k free',0
szAllFiles         db    '*.*',0
ToolClass         db    'ToolbarWindow32',0
listbox           db    'LISTBOX',0
combobox          db    'COMBOBOX',0
Edit              db    'EDIT',0
Stat              db    'STATIC',0
Butt              db    'BUTTON',0
szPaintBr         db    'PBRUSH.EXE',0
szWrite           db    'Notepad.exe',0
GoBack            db    'GoBack',0
Refresh           db    'Refresh',0
Exit              db    'E X I T',0 
Butt1             db    '  Copy',0
Butt2             db    '  Move',0
Butt3             db    'Rename',0
Butt4             db    ' Delete',0
Butt5             db    'Make Dir',0
P                 db    'P',0
szEdit            db    'User &Edit',0
szPaste           db    '&Paste',0
szRename          db    'Rename',0
szRecyc           db    'RECYCLED',0

;---------------------------------------------------------------------------------
.data
hWndTree          dd        0                   ; Window handle for the Tree View
hCImageList       dd        0
hImageList        dd        0
hSingleImage      dd        0
hTreeImageList    dd        0
hitemMyComputer   dd        0

hWnd1             dd        0
hButt             dd        0
hIcon             dd        0
hTB01             dd        0
hToolBar          dd        26 dup(?)
hWndTool          dd        0
hToolBarC         dd        4 dup(?)
hToolBarM         dd        0
hComboL           dd        0
hComboR           dd        0
hStatL            dd        0
hStatR            dd        0
hToolBarL         dd        0
hToolBarR         dd        0
hFont             dd        0
SubTool           dd        0
hDrives           dd        26 dup(0)
DriveArray        dd        26 dup(0)
ControlArray      dd        26 dup(0)
SaveArray         dd        26 dup(0)
TreeLevCntL       dd        0
TreeLevelL        dd        20  dup(0)

hDC               dd        0
ToolBarCnt        dd        0
SavButtL          dd        1
SavButtR          dd        1
RetSavButtL       dd        99  ; Don't change
RetSavButtR       dd        99  ; Don't change
First             dd        0
FirstSort         dd        0
Init              dd        0
XP                dd        0
ImageID           dd        0
Xicon             dd        0
Yicon             dd        0
W                 dd        0
Cmd               dd        0
HoldCnt           dd        0
HoldCntC          dd        0
secPerClus        dd        0 
bytePerSec        dd        0
freeClus          dd        0
totalClus         dd        0
Savptvobj         dd        0
OneK              REAL10    1024.0
AvailQ            QWORD     0
TotalQ            QWORD     0
TFreeQ            QWORD     0
AvailD            dd        0
TotalD            dd        0
szAvail           db        16 dup(0), 0
szTotal           db        16 dup(0), 0
szDrvLet          db        30 dup(0), 0
szBuff            db        60 dup(0), 0
szWork            db        60 dup(0), 0
szToolTip         db        60 dup(0), 0
szHeader          db        60 dup(0), 0
szDrv             db        5  dup(0), 0
szVol             db        20 dup(0), 0
WBuff             db        4  dup(0), 0
szZero            db        20 dup(0), 0
FromTree          dd        0
AutoTree          dd        0

strret     STRRET       <?>
lf         LOGFONT      <?>
rect       RECT         <?>
sfi        SHFILEINFO   <>
;bri        BROWSEINFO   <>

.code       

;=========================================================================|
; InitTreeView PROCEDURE                                                  |
;=========================================================================|
InitTreeView proc hInstance:DWORD, hWnd:DWORD
LOCAL    lpsf:LPSHELLFOLDER

        push     hWnd
         pop     hWndP

;---------- [Get parent window size] ----------
      INVOKE     GetClientRect, hWnd, addr rect     
         mov     eax, rect.right
         shr     eax, 1
         dec     eax

;---------- [Create the tree view window] ----------
         mov     eax, 1
      .if (ViewFlags & 2) || (ViewFlags & 4)
         mov     eax, TreeVWidth
         add     eax, 4
      .endif
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr szTreeClassName, 0,
                 WS_CHILD or WS_VISIBLE or TVS_HASLINES or TVS_HASBUTTONS or TVS_LINESATROOT,
                 0, 78, eax, rect.bottom, hWndP, ID_TREEVIEW, hInstance, NULL
        test     eax,eax     
         jz      ret_error
         mov     hWndTree, eax 
                         
;---------- [Get the shell image list for the tree view] ----------
      INVOKE     SHGetFileInfo, addr szRootPath, 0, addr sfi, sizeof SHFILEINFO, SHGFI_SYSICONINDEX or SHGFI_SMALLICON
        test     eax,eax
         jz      ret_error
         mov     hTreeImageList, eax 
      INVOKE     SendMessage, hWndTree, TVM_SETIMAGELIST, 0, eax

;---------- [Initialize the tree window] ----------
      INVOKE     SHGetDesktopFolder, addr lpsf
        test     eax,eax
         js      ret_error

;---------- [Fill the window with the root items] ----------
      INVOKE     UpdateTreeView, hWndTree, lpsf, 0, TVI_ROOT
;UpdateTreeView proc uses ebx edx hWnd:DWORD, pshfParent:LPSHELLFOLDER, pidlFull:LPITEMIDLIST, htreeParent:DWORD

;---------- [Free the shell folder pointer] ----------
         mov     eax, lpsf
         mov     eax, [eax]
      INVOKE     (IShellFolder ptr [eax]).Release, lpsf

ret_ok:                     
         mov     eax, 1
         ret
ret_error:
         xor     eax, eax
         ret
InitTreeView     endp

;=========================================================================|
; UpdateTreeView PROCEDURE                                                |
;=========================================================================|
align DWORD
UpdateTreeView proc uses ebx edx hWnd:DWORD, pshfParent:LPSHELLFOLDER, pidlFull:LPITEMIDLIST, htreeParent:DWORD
LOCAL    peidl       :LPENUMIDLIST
LOCAL    pidl        :LPITEMIDLIST
LOCAL    pidlFullCur :LPITEMIDLIST
LOCAL    ptvobj      :LPTV_OBJDATA
LOCAL    tvis        :TV_INSERTSTRUCT
LOCAL    tbb         :TBBUTTON
LOCAL    dwAttr      :DWORD
LOCAL    bFirstItem  :DWORD
LOCAL    Work [60]   :BYTE
LOCAL    bID         :DWORD, cID:DWORD, cnt:DWORD, cntC:DWORD

         mov     edx, pshfParent
         mov     edx, [edx]
      INVOKE     (IShellFolder PTR [edx]).EnumObjects, pshfParent, hWnd, SHCONTF_FOLDERS or\
                 SHCONTF_NONFOLDERS or SHCONTF_INCLUDEHIDDEN, addr peidl
        test     eax, eax
         js      ret_error
         mov     bFirstItem, 1
         mov     First, 1
         mov     cnt, 0
         mov     cntC, 0
      INVOKE     ImageList_Create, 16, 16, ILC_COLOR16 or ILC_MASK, 1, 26
         mov     hImageList, eax
      INVOKE     ImageList_Create, 16, 16, ILC_COLOR16 or ILC_MASK, 1, 4
         mov     hCImageList, eax
;mov     eax, 7777
;DSPValue hWndP, eax
;DSPValue hWndP, htreeParent

ObjectLoop:
         mov     edx, peidl
         mov     edx,[edx]
      INVOKE     (IEnumIDList PTR [edx]).Next, peidl, 1, addr pidl, NULL
        test     eax,eax
         js      ret_error
         cmp     eax,S_FALSE    ; No more items
         jz      CreateTB

;---------- [Check to see if its a folder; if its a folder, add it to the tree] ----------
         mov     dwAttr, SFGAO_HASSUBFOLDER or SFGAO_FOLDER
         mov     edx, pshfParent
         mov     edx, [edx]
      INVOKE     (IShellFolder PTR [edx]).GetAttributesOf, pshfParent, 1, addr pidl, addr dwAttr
        test     eax,eax
         js      ret_error

      .if          dwAttr & (SFGAO_HASSUBFOLDER or SFGAO_FOLDER)
         .if          dwAttr & SFGAO_FOLDER
;---------- [Save TV_OBJDATA] ----------
               mov     eax, pShellMalloc
               mov     eax,[eax]
            INVOKE     (IMalloc ptr [eax]).Alloc, pShellMalloc, sizeof TV_OBJDATA              
              test     eax,eax
               jz      ret_error
               mov     ptvobj,eax
               mov     ebx, eax            
 
            INVOKE     IDList_Combine, pidlFull, pidl  
               mov     (TV_OBJDATA PTR [ebx]).pidlFull, eax
               mov     pidlFullCur, eax

            INVOKE     IDList_CopyItem, pidl
               mov     (TV_OBJDATA PTR [ebx]).pidlRel, eax                    
               mov     eax, pshfParent
               mov     (TV_OBJDATA PTR [ebx]).pshfParent, eax
               mov     tvis.item.lParam, ebx
         
;---------- [Save tree item data] ----------
               mov     eax, htreeParent
               mov     tvis.hParent, eax
               mov     tvis.item.hItem, 0  
               mov     tvis.hInsertAfter, TVI_LAST
;    mov     tvis.hParent, TVI_ROOT
;    mov     tvis.hInsertAfter,TVI_SORT
               mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE or TVIF_PARAM
            .if dwAttr & SFGAO_HASSUBFOLDER
                  mov     tvis.item.cChildren, TRUE
                  or      tvis.item.imask, TVIF_CHILDREN                         
            .endif
               mov     edx, pshfParent
               mov     edx,[edx]
            INVOKE     (IShellFolder PTR [edx]).GetDisplayNameOf, pshfParent, pidl, SHGDN_NORMAL, addr strret
              test     eax,eax
               js      ret_error
            .if strret.uType == STRRET_CSTR
                  lea     eax, strret.cStr
            .elseif strret.uType == STRRET_OFFSET
                  mov       eax, pidl
                  add       eax, strret.uOffset
            .elseif strret.uType == STRRET_WSTR
                  mov     eax, strret.pOleStr
            .endif

               mov     tvis.item.pszText, eax
               mov     tvis.item.cchTextMax, 255
;INVOKE    MessageBox,NULL, eax, offset szTreeClassName, MB_OK
            INVOKE     GetIcon, pidlFullCur, SHGFI_ICON
               mov     tvis.item.iImage, eax

            INVOKE     SHGetFileInfo, pidlFullCur, 0, addr sfi, sizeof SHFILEINFO,
                       SHGFI_PIDL or SHGFI_DISPLAYNAME ;or SHGFI_ATTRIBUTES ; SHGFI_TYPENAME causes a problem
              test     eax,eax
               jz      ret_error
            INVOKE     lstrcpy, addr Work, addr sfi.szDisplayName
               lea     eax, sfi.szDisplayName
               mov     tvis.item.pszText, eax

;INVOKE    MessageBox,NULL, addr sfi.szDisplayName, offset szTreeClassName, MB_OK

;------------ [Build the control panel image list] ------------
            .if dword ptr Work == 'tnoC' || dword ptr Work == 'nirP' || dword ptr Work == 'ehcS' || dword ptr Work == 'laiD'
                  mov     eax, cntC
                 imul     eax, 4
                  mov     edx, eax
                MOVmd     ControlArray+[edx], ptvobj
                  add     cntC, 1
               INVOKE     GetIcon, pidlFullCur, SHGFI_ICON
               INVOKE     ImageList_AddIcon, hCImageList, hIcon  ; hIcon gets loaded in GetIcon
            .endif

;------------ [Build the the drive list] ------------
            INVOKE     lstrlen, addr Work
               sub     eax, 3
               lea     ebx, Work
               add     ebx, eax
            .if word ptr [ebx+1] == '):'
               INVOKE     lstrcpyn, addr Work, ebx, 2
                  add     Work, 32                               ; Convert to lower case
               .if First == 1
                     and     First, 0
                  INVOKE     lstrcpy, addr szDrvLet, addr Work
               .else
                  INVOKE     lstrcat, addr szDrvLet, addr Work     ; szDrvLet = drive letters
               .endif

;------------ [Build the the drive ptvobj array] ------------
                  mov     eax, cnt
                MOVmd     DriveArray+[eax*4], ptvobj
                  add     cnt, 1

;------------ [Build the drive image list] ------------
               INVOKE     GetIcon, pidlFullCur, SHGFI_ICON
               INVOKE     ImageList_AddIcon, hImageList, hIcon   ; hIcon gets loaded in GetIcon
            .endif

            INVOKE     GetIcon, pidlFullCur, SHGFI_OPENICON 
               mov     tvis.item.iSelectedImage, eax

;--------------- [Add item to the tree] ---------------
            INVOKE     SendMessage, hWnd, TVM_INSERTITEM, 0, addr tvis 
              test     eax,eax
               jz      ret_error                
            .if bFirstItem == TRUE
                  mov     hitemMyComputer, eax     ; Handle for My Computer
                  mov     bFirstItem, 0
            .endif
;            .if byte ptr Work == 'c' && !DrvC
;                  mov     DrvC, eax                ; Handle for Drive 'C'
;            .endif

            .if byte ptr Work > 96 && byte ptr Work < 123 && cnt  ; All drives
               mov     ebx, eax
               mov     eax, cnt
               dec     eax
               mov     hDrives+[eax*4], ebx        ; Drive handles
            .endif

         .endif     
      .endif

;***************** I don't think this is freeing everything ****************
;--------------- [Free the resource] ---------------
         mov     eax, pShellMalloc
         mov     eax,[eax]
      INVOKE     (IMalloc PTR [eax]).Free, pShellMalloc, pidl

         jmp     ObjectLoop

CreateTB:
      .if ToolBarCnt > 2
            jmp      End_ObjectLoop
      .endif
         add     ToolBarCnt, 1
;====================================================================================|
; ------------------------------- [Build the toolbars] ------------------------------|
;====================================================================================|

; Need to save the DriveArray, because the call to FindFirstFile screws it up. I'm looking into it.
            xor     ecx, ecx
            xor     eax, eax
         .while (ecx < 26)
             MOVmd     SaveArray[eax], DriveArray[eax]
               inc     eax
               inc     ecx
         .endw  

      INVOKE     ImageList_GetImageCount, hCImageList
         cmp     eax, 0
         je      DriveToolBar
         jmp     Past

tb       TBBUTTON    <0,100,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <1,101,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <2,102,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbbb     TBBUTTON    <3,103,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl      equ         $-tbbb

Past:

;------------------------ [Control panel, printers, etc. toolbars] ------------------------
      INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                 WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or CCS_NORESIZE or\
                 TBSTYLE_FLAT,
                 0,0,100,24, hWndP, 44, hInst,NULL  ;0,0,120,24
         mov     hToolBarC, eax

      INVOKE     SendMessage, hToolBarC, TB_BUTTONSTRUCTSIZE, tbl, 0
      INVOKE     SendMessage, hToolBarC, TB_SETIMAGELIST, 0, hCImageList
      INVOKE     SendMessage, hToolBarC, TB_ADDBUTTONS, cntC, addr tb

;------------------------ [Copy, Rename, Delete, Make Dir, Close toolbars] ------------------------
; or CCS_VERT or CCS_NODIVIDER
      INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                 WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or CCS_NORESIZE or\
                 TBSTYLE_FLAT or TBSTYLE_LIST or TBSTYLE_WRAPABLE,
                 100,0,370,24, hWndP, 45, hInst,NULL  ;120,0,370,24
         mov     hToolBarM, eax
      INVOKE     lstrcpy, addr lf.lfFaceName, addr FontName
      .if osvID < 2
         mov     lf.lfHeight, -9  ; -9 for win9x -12 for NT
      .else
         mov     lf.lfHeight, -12
      .endif  
         mov     lf.lfWeight, 600
      INVOKE     CreateFontIndirect, addr lf
      INVOKE     SendMessage, hToolBarM, WM_SETFONT, eax, 1

      INVOKE     SendMessage, hToolBarM, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0

         mov     eax, 00100000h  ;00a0032h
      INVOKE     SendMessage, hToolBarM, TB_SETBITMAPSIZE, 0, eax

       TBSep     hToolBarM
      INVOKE     SendMessage, hToolBarM, TB_ADDSTRING, 0, addr Butt1
      TBButt     hToolBarM, 0, 104, eax
       TBSep     hToolBarM
      INVOKE     SendMessage, hToolBarM, TB_ADDSTRING, 0, addr Butt2
      TBButt     hToolBarM, 0, 105, eax
       TBSep     hToolBarM
      INVOKE     SendMessage, hToolBarM, TB_ADDSTRING, 0, addr Butt3
      TBButt     hToolBarM, 0, 106, eax
       TBSep     hToolBarM
      INVOKE     SendMessage, hToolBarM, TB_ADDSTRING, 0, addr Butt4
      TBButt     hToolBarM, 0, 107, eax
       TBSep     hToolBarM
      INVOKE     SendMessage, hToolBarM, TB_ADDSTRING, 0, addr Butt5
      TBButt     hToolBarM, 0, 108, eax
       TBSep     hToolBarM

;------------------------ [EXIT Toolbar] ------------------------
      INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                 WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or CCS_NORESIZE or\
                 TBSTYLE_FLAT or TBSTYLE_LIST or TBSTYLE_WRAPABLE,
                 468,0,100,24, hWndP, 52, hInst,NULL  ;488,0,100,24
         mov     hTB01, eax

      INVOKE     ImageList_Create,16,16,ILC_COLOR16 or ILC_MASK,1,2
         mov     hSingleImage, eax
      INVOKE     LoadIcon, hInst, IDI_EXIT
         mov     hIcon, eax
      INVOKE     ImageList_AddIcon, hSingleImage, hIcon
      INVOKE     DeleteObject, hIcon

      INVOKE     lstrcpy, addr lf.lfFaceName, addr FontName
      .if osvID < 2
         mov     lf.lfHeight, -12  ; -12 for win9x -14 for NT
         mov     lf.lfWidth, 4
      .else
         mov     lf.lfHeight, -14
         mov     lf.lfWidth, 8
      .endif  
         mov     lf.lfWeight, 800
      INVOKE     CreateFontIndirect, addr lf
      INVOKE     SendMessage, hTB01, WM_SETFONT, eax, 1

      INVOKE     SendMessage, hTB01, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
      INVOKE     SendMessage, hTB01, TB_SETIMAGELIST, 0, hSingleImage

         mov     eax, 00100010h  ;000f0010h
      INVOKE     SendMessage, hTB01, TB_SETBITMAPSIZE, 0, eax
         mov     eax, 000f0032h
      INVOKE     SendMessage, hTB01, TB_SETBUTTONSIZE, 0, eax
      INVOKE     SendMessage, hTB01, TB_ADDSTRING, 0, addr Exit
      TBButt     hTB01, 0, 1005, 0
       TBSep     hTB01

;------------------------ [NotePad PaintBrush ControlPanel DeskTop  Toolbars] ------------------------
         mov     cnt, 0
         mov     XP, 568  ;588
         mov     W, 30 
         mov     cID, 711

      .while (cnt < 4)
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or CCS_NORESIZE or\
                    TBSTYLE_FLAT or TBSTYLE_LIST or TBSTYLE_WRAPABLE,
                    XP,0,W,24, hWndP, 52, hInst,NULL
            mov     hTB01, eax
   
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR16 or ILC_MASK, 1, 2
            mov     hSingleImage, eax
         
         .if cnt == 0
            INVOKE     LoadIcon, hInst, 9003         ; Note pad
               mov     hIcon, eax
            INVOKE     ImageList_AddIcon, hSingleImage, hIcon
   
         .elseif cnt == 1
            INVOKE     ExtractIcon, hInst, addr szPaintBr, 0  ; Paint brush
               mov     hIcon, eax
            INVOKE     ImageList_AddIcon, hSingleImage, hIcon
   
         .elseif cnt == 2
            INVOKE     LoadIcon, hInst, 9001         ; Control panel
               mov     hIcon, eax
            INVOKE     ImageList_AddIcon, hSingleImage, hIcon

         .elseif cnt == 3
            INVOKE     LoadIcon, hInst, 9002         ; Desk top
               mov     hIcon, eax
            INVOKE     ImageList_AddIcon, hSingleImage, hIcon
         .endif
         INVOKE     DeleteObject, hIcon

         INVOKE     SendMessage, hTB01, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
         INVOKE     SendMessage, hTB01, TB_SETIMAGELIST, 0, hSingleImage

            mov     eax, 00100010h  ;000f0010h
         INVOKE     SendMessage, hTB01, TB_SETBITMAPSIZE, 0, eax
            mov     eax, 000f001ah  ;000f0032h
         INVOKE     SendMessage, hTB01, TB_SETBUTTONSIZE, 0, eax
            mov     eax, cID
         TBButt     hTB01, 0, eax, 0
            add     cnt, 1
            add     XP, 30
         .if cnt == 3
               mov     W, 1000
         .endif
            add     cID, 1
      .endw

                  INVOKE     CreateWindowEx,NULL, addr Butt,0,
                             WS_CHILD or WS_VISIBLE or BS_ICON,
                             40,0,40,22,hTB01,4444,hInst,NULL  ;70,0,40,22
                     mov     hButt, eax
                  INVOKE     ImageList_GetIcon, hImageList, 0, ILD_NORMAL ;14
                  INVOKE     SendMessage, hButt, BM_SETIMAGE, IMAGE_ICON, eax  ;hIcon  ;eax

;------------------------ [Drive Toolbar] ------------------------
DriveToolBar:
      INVOKE     ImageList_GetImageCount, hImageList
         cmp     eax, 0
         je      End_ObjectLoop
         dec     eax
         mov     cnt, eax
         mov     HoldCnt, eax
         mov     XP, 0
         mov     W, 36 ;41 ;38
         mov     bID, 0
         mov     cID, 200
         mov     ImageID, 0

      INVOKE     lstrcpy, addr lf.lfFaceName, addr FontName ;FontName1
         mov     lf.lfHeight, -12
         mov     lf.lfWidth, 0
         mov     lf.lfWeight, 600
      INVOKE     CreateFontIndirect, addr lf
         mov     hFont, eax

BuildTB:
      INVOKE     ImageList_Create,16,16,ILC_COLOR16 or ILC_MASK,1,2
         mov     hSingleImage, eax
      INVOKE     ImageList_GetIcon, hImageList, ImageID, ILD_NORMAL
         mov     hIcon, eax
      INVOKE     ImageList_AddIcon, hSingleImage, hIcon
      INVOKE     DeleteObject, hIcon

         mov     eax, ImageID
        imul     eax, 4
         mov     edx, eax
        push     edx  

      INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                 WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                 CCS_NORESIZE or TBSTYLE_FLAT or TBSTYLE_LIST or TBSTYLE_WRAPABLE,
                 XP,24,W,24, hWndP, ImageID, hInst, NULL
         mov     hTB01, eax

         pop     edx
         mov     hToolBar+[edx], eax
      INVOKE     SetWindowLong, hTB01, GWL_WNDPROC, ToolbarProc
         mov     SubTool, eax
      INVOKE     SendMessage, hTB01, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
      INVOKE     SendMessage, hTB01, TB_SETIMAGELIST, 0, hSingleImage

         mov     eax, 0010000fh ;0010000fh                            ; hword = height, lword = width
      INVOKE     SendMessage, hTB01, TB_SETBITMAPSIZE, 0, eax

      INVOKE     SendMessage, hTB01, WM_SETFONT, hFont, 1
         mov     eax, ImageID
      INVOKE     lstrcpyn, addr WBuff, addr szDrvLet+[eax], 2
         mov     eax, cID
      TBButt     hTB01, 0, eax, offset WBuff

         mov     eax, 000000022h
      INVOKE     SendMessage, hTB01, TB_SETBUTTONSIZE, 0, eax

      .if cnt > 0
            sub     cnt, 1
            add     ImageID, 1
            add     cID, 1
            add     XP, 36 ;41
         .if cnt == 0
               mov     W, 1000
         .endif
            jmp     BuildTB
      .endif

;------------------------ Combo Boxes] ------------------------
      INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                 WS_CHILD or WS_VISIBLE or CCS_NOPARENTALIGN or\
                 CCS_NORESIZE,
                 0,48,1200,24,hWndP,1,hInst,NULL
         mov     hWndTool, eax

      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, offset combobox, 0,
                 WS_VSCROLL or WS_VISIBLE or WS_CHILD or CBS_HASSTRINGS or\
                 CBS_NOINTEGRALHEIGHT or CBS_DROPDOWN or WS_BORDER,
                 3,-2,50,450, hWndTool, 50, hInst, 0
         mov     hComboL, eax

      INVOKE     SendMessage, hComboL, CB_DIR, DDL_DRIVES or DDL_EXCLUSIVE, addr szAllFiles
      INVOKE     SendMessage, hComboL, CB_SETCURSEL, 1, 0
      INVOKE     SendMessage, hComboL, CB_SETITEMHEIGHT, -1, 15
      INVOKE     SendMessage, hComboL, CB_SETITEMHEIGHT, 1, 15

      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, offset combobox, 0,
                 WS_VSCROLL or WS_VISIBLE or WS_CHILD or CBS_HASSTRINGS or\
                 CBS_NOINTEGRALHEIGHT or CBS_DROPDOWN or WS_BORDER,
                 396,-2,50,450, hWndTool, 51, hInst, 0
         mov     hComboR, eax

      INVOKE     SendMessage, hComboR, CB_DIR, DDL_DRIVES or DDL_EXCLUSIVE, addr szAllFiles
      INVOKE     SendMessage, hComboR, CB_SETCURSEL, 1, 0
      INVOKE     SendMessage, hComboR, CB_SETITEMHEIGHT, -1, 15
      INVOKE     SendMessage, hComboR, CB_SETITEMHEIGHT, 1, 15

;------------------------ [Static Windows] ------------------------
      INVOKE     CreateWindowEx, 0, addr Stat, 0,
                 WS_CHILD or WS_VISIBLE or CCS_NOPARENTALIGN or CCS_NORESIZE,
                 57,+4,200,20, hWndTool, 52, hInst, 0
         mov     hStatL, eax
      INVOKE     SendMessage, hStatL, WM_SETFONT, hFontL, 1
      INVOKE     SetWindowText, hStatL, addr ToolClass

      INVOKE     CreateWindowEx, 0, addr Stat, 0,
                 WS_CHILD or WS_VISIBLE or CCS_NOPARENTALIGN or CCS_NORESIZE,
                 450,+4,200,20, hWndTool, 52, hInst, 0
         mov     hStatR, eax
      INVOKE     SendMessage, hStatR, WM_SETFONT, hFontL, 1
      INVOKE     SetWindowText, hStatR, addr ToolClass

;------------------------ [Refresh Toolbars] ------------------------==
      INVOKE     ImageList_Create,16,16,ILC_COLOR16 or ILC_MASK,1,2
         mov     hSingleImage, eax
      INVOKE     LoadIcon, hInst, 9004         ; Refresh
         mov     hIcon, eax
      INVOKE     ImageList_AddIcon, hSingleImage, hIcon
      INVOKE     DeleteObject,hIcon

      INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                 WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                 CCS_NORESIZE or TBSTYLE_FLAT or TBSTYLE_LIST,
                 3,-2,70,24, hWndTool, 48, hInst,NULL
         mov     hToolBarL, eax
      INVOKE     SetWindowLong, hToolBarL, GWL_WNDPROC, ToolbarProc
         mov     SubTool, eax

      INVOKE     SendMessage, hToolBarL, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
      INVOKE     SendMessage, hToolBarL, TB_SETIMAGELIST, 0, hSingleImage

         mov     eax, 000f0010h
      INVOKE     SendMessage, hToolBarL, TB_SETBITMAPSIZE, 0, eax
         mov     eax, 000f0032h
      INVOKE     SendMessage, hToolBarL, TB_SETBUTTONSIZE, 0, eax

      INVOKE     SendMessage, hToolBarL, TB_ADDSTRING, 0, addr Refresh
      TBButt     hToolBarL, 0, 120, 0

      INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                 WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                 CCS_NORESIZE or TBSTYLE_FLAT or TBSTYLE_LIST,
                 396,-2,70,24, hWndTool, 49, hInst,NULL
         mov     hToolBarR, eax
      INVOKE     SetWindowLong, hToolBarR, GWL_WNDPROC, ToolbarProc
         mov     SubTool, eax

      INVOKE     SendMessage, hToolBarR, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
      INVOKE     SendMessage, hToolBarR, TB_SETIMAGELIST, 0, hSingleImage

         mov     eax, 000f0010h
      INVOKE     SendMessage, hToolBarR, TB_SETBITMAPSIZE, 0, eax
         mov     eax, 000f0032h
      INVOKE     SendMessage, hToolBarR, TB_SETBUTTONSIZE, 0, eax

      INVOKE     SendMessage, hToolBarR, TB_ADDSTRING, 0, addr Refresh
      TBButt     hToolBarR, 0, 121, 0

End_ObjectLoop:

;         mov     eax, peidl
;         mov     eax,[eax]
;      INVOKE     (IEnumIDList PTR [eax]).Release, peidl

ret_ok:
         ret
ret_error:
         ret
UpdateTreeView endp

;=========================================================================|
; Processes toolbar input PROCEDURE                                       |
;=========================================================================|
ToolbarProc   PROC uses ebx edx hwnd:DWORD, wMsg:DWORD, wParam:DWORD, lParam:DWORD
;LOCAL    pshf:LPSHELLFOLDER
LOCAL    pshfw:LPSHELLFOLDER
LOCAL    ptvobj:LPTV_OBJDATA

         mov     eax, wMsg
      .if eax == WM_CALLTOOLPROC    ; Call from control toolbar or combobox
            jmp     wmcommand
      .endif
      INVOKE     CallWindowProc, SubTool, hwnd, wMsg, wParam, lParam

         mov     eax, wMsg
         cmp     eax, WM_COMMAND
         je      wmcommand
;         cmp     eax, WM_NOTIFY
;         je      wmnotify
         jmp     GetOut

wmcommand:
      .if wParam > 99 && wParam < 104 || wParam > 199 && wParam < 226

         .if SavList == 4 && sw2 != 8  ; If sw2 = 8 its startup and column sizing 
               mov     eax, SavButtL
               cmp     eax, wParam     ; If trying to reload the same drive
               je      GetOut

            .if wParam < 200
                MOVmd     RetSavButtL, SavButtL
                MOVmd     SavButtL, wParam
                  jmp     SavRetL
            .endif

;----- [See if the left view is changing to the same drive as the right view] -----
               mov     eax, wParam
            .if eax == SavButtR
               INVOKE     ExpColTree, SavButtL, 0 ; 1 = expand, 0 = collaspe

                MOVmd     RetLevCntL, LevCntL
                MOVmd     LevCntL, LevCntR
                MOVmd     RetSavButtL, SavButtL
               INVOKE     lstrcpy, addr RetRestoreL, addr RestoreL
               INVOKE     lstrcpy, addr RestoreL, addr RestoreR
               INVOKE     lstrcpy, addr RetBackHighLiteL, addr BackHighLiteL
               INVOKE     lstrcpy, addr BackHighLiteL, addr BackHighLiteR
               INVOKE     SetButt, wParam
               INVOKE     lstrcpy, addr SavPath, addr szPathR
               INVOKE     lstrcpy, addr RetszPathL, addr szPathL
               INVOKE     lstrcpy, addr szPathL, addr szPathR
               INVOKE     lstrcpy, addr RetszTitleL, addr szTitleL
               INVOKE     lstrcpy, addr szTitleL, addr szTitleR
               INVOKE     SetWindowText, hStatL, addr szTitleL
               INVOKE     ListViewRefresh, SavList

               INVOKE     ExpColTree, SavButtL, 1   ; 1 = expand, 0 = collaspe
                  jmp     GetOut
            .endif

;----- [See if the left view is going back to the drive it came from] -----
               mov     eax, wParam
            .if eax == RetSavButtL
               INVOKE     ExpColTree, SavButtL, 0 ; 1 = expand, 0 = collaspe

                MOVmd     LevCntL, RetLevCntL
               INVOKE     lstrcpy, addr RestoreL, addr RetRestoreL
               INVOKE     lstrcpy, addr BackHighLiteL, addr RetBackHighLiteL
               INVOKE     SetButt, wParam
               INVOKE     lstrcpy, addr SavPath, addr RetszPathL
               INVOKE     lstrcpy, addr szPathL, addr RetszPathL
               INVOKE     lstrcpy, addr szTitleL, addr RetszTitleL
               INVOKE     SetWindowText, hStatL, addr szTitleL
               INVOKE     ListViewRefresh, SavList

               INVOKE     ExpColTree, SavButtL, 1   ; 1 = expand, 0 = collaspe
                  jmp     GetOut
            .endif

;----- [Save for return] ------
             MOVmd     RetSavButtL, SavButtL

SavRetL:
            INVOKE     ExpColTree, SavButtL, 0 ; 1 = expand, 0 = collaspe
            INVOKE     ExpColTree, wParam, 1   ; 1 = expand, 0 = collaspe

             MOVmd     RetLevCntL, LevCntL
            INVOKE     lstrcpy, addr RetRestoreL, addr RestoreL
            INVOKE     lstrcpy, addr RetBackHighLiteL, addr BackHighLiteL
      INVOKE     lstrcpy, addr BackHighLiteL, addr szZero
            INVOKE     lstrcpy, addr RetszPathL, addr szPathL
            INVOKE     lstrcpy, addr RetszTitleL, addr szTitleL

         .elseif SavList == 8 && sw2 != 8  ; If sw2 = 8 its startup and column sizing
               mov     eax, SavButtR
               cmp     eax, wParam         ; If trying to reload the same drive
               je      GetOut
 
            .if wParam < 200
                MOVmd     RetSavButtR, SavButtR
                MOVmd     SavButtR, wParam
                  jmp     SavRetR
            .endif

;----- [See if the right view is changing to the same drive as the left view] ------
               mov     eax, wParam
            .if eax == SavButtL
               INVOKE     ExpColTree, SavButtR, 0 ; 1 = expand, 0 = collaspe

                MOVmd     RetLevCntR, LevCntR
                MOVmd     LevCntR, LevCntL
                MOVmd     RetSavButtR, SavButtR
               INVOKE     lstrcpy, addr RetRestoreR, addr RestoreR
               INVOKE     lstrcpy, addr RestoreR, addr RestoreL
               INVOKE     lstrcpy, addr RetBackHighLiteR, addr BackHighLiteR
               INVOKE     lstrcpy, addr BackHighLiteR, addr BackHighLiteL
               INVOKE     SetButt, wParam
               INVOKE     lstrcpy, addr SavPath, addr szPathL
               INVOKE     lstrcpy, addr RetszPathR, addr szPathR
               INVOKE     lstrcpy, addr szPathR, addr szPathL
               INVOKE     lstrcpy, addr RetszTitleR, addr szTitleR
               INVOKE     lstrcpy, addr szTitleR, addr szTitleL
               INVOKE     SetWindowText, hStatR, addr szTitleR
               INVOKE     ListViewRefresh, SavList

               INVOKE     ExpColTree, SavButtR, 1 ; 1 = expand, 0 = collaspe
                  jmp     GetOut
            .endif

;----- [See if the RIGHT view is going back to the drive it came from] -----
               mov     eax, wParam
            .if eax == RetSavButtR
               INVOKE     ExpColTree, SavButtR, 0 ; 1 = expand, 0 = collaspe

                MOVmd     LevCntR, RetLevCntR
               INVOKE     lstrcpy, addr RestoreR, addr RetRestoreR
               INVOKE     lstrcpy, addr BackHighLiteR, addr RetBackHighLiteR
               INVOKE     SetButt, wParam
               INVOKE     lstrcpy, addr SavPath, addr RetszPathR
               INVOKE     lstrcpy, addr szPathR, addr RetszPathR
               INVOKE     lstrcpy, addr szTitleR, addr RetszTitleR
               INVOKE     SetWindowText, hStatR, addr szTitleR
               INVOKE     ListViewRefresh, SavList

               INVOKE     ExpColTree, SavButtR, 1 ; 1 = expand, 0 = collaspe
                  jmp     GetOut
            .endif

;----- [Save for return] ------
             MOVmd     RetSavButtR, SavButtR

SavRetR:
            INVOKE     ExpColTree, SavButtR, 0 ; 1 = expand, 0 = collaspe
            INVOKE     ExpColTree, wParam, 1   ; 1 = expand, 0 = collaspe

             MOVmd     RetLevCntR, LevCntR
            INVOKE     lstrcpy, addr RetRestoreR, addr RestoreR
            INVOKE     lstrcpy, addr RetBackHighLiteR, addr BackHighLiteR
      INVOKE     lstrcpy, addr BackHighLiteR, addr szZero
            INVOKE     lstrcpy, addr RetszPathR, addr szPathR
            INVOKE     lstrcpy, addr RetszTitleR, addr szTitleR
         .endif              ; .if SavList == 4 && sw2 != 8,  .elseif  SavList == 8 && sw2 != 8
 
LoadEm:
         INVOKE     SetButt, wParam
          MOVmd     ptvobj, Savptvobj
            mov     ebx, ptvobj
            mov     edx, (TV_OBJDATA ptr [ebx]).pshfParent
            mov     edx, [edx]
         INVOKE     (IShellFolder PTR [edx]).BindToObject,
                    (TV_OBJDATA ptr [ebx]).pshfParent, 
                    (TV_OBJDATA ptr [ebx]).pidlRel, 0, addr IID_IShellFolder, addr pshf
           test     eax,eax
            js      ret_error
         INVOKE     CopyData, SavList, ptvobj, pshf

;----- [Fill the list view] ------
            and     sw1, 0
            mov     edx, ptvobj
            mov     ebx, (TV_OBJDATA ptr [edx]).pidlFull
           push     ebx
         INVOKE     SHGetPathFromIDList, ebx, addr SavPath
            mov     byte ptr szDrv+1, 0     
         INVOKE     lstrcpy, addr szDrv, addr SavPath
         INVOKE     lstrcat, addr SavPath, addr szAllFiles

         INVOKE     GetDrvRoot, ptvobj
           call     GetHeader

         .if SavList == 8
            .if wParam > 199 && wParam < 226 && sw2 != 8  ; If sw2 = 8 its startup and column sizing
                  mov     RestoreR, 000000ffh
            .endif
               mov     ecx, hWndListR
         .else
            .if wParam > 199 && wParam < 226 && sw2 != 8
                  mov     RestoreL, 000000ffh
            .endif
               mov     ecx, hWndListL
         .endif

         .if wParam > 99 && wParam < 104
               mov     KillThread, 1
            .if SavList == 4
               INVOKE     ExpColTree, RetSavButtL, 0 ; 1 = expand, 0 = collaspe
            .else
               INVOKE     ExpColTree, RetSavButtR, 0 ; 1 = expand, 0 = collaspe
            .endif
         .endif

            pop     ebx
         INVOKE     UpdateListView, ecx, ebx, pshf
           test     eax,eax
            jz      GoToPrev  ;ret_error
            mov     eax, pshf
            mov     eax, [eax]
         INVOKE     (IShellFolder ptr [eax]).Release, pshf
         INVOKE     UpdateSelBars
            jmp     ret_ok
      .endif
         jmp     ret_ok

GoToPrev:
      .if SavList == 4
          MOVmd     wParam, RetSavButtL
      .else
          MOVmd     wParam, RetSavButtR
      .endif
      .if wParam > 199 && wParam < 226
            jmp     wmcommand
      .else
            jmp     ret_error  ; ???????????????????
      .endif

; Not used any more
wmnotify:
        push     HoldCnt
         mov     eax, HoldCnt
      .if wParam == eax
         mov     XP, 0
         mov     ImageID, 0

BuildLet:
         mov     eax, ImageID
        imul     eax, 4
         mov     edx, hToolBar+[eax]
         mov     hTB01, edx
      INVOKE     GetDC, hTB01
         mov     hDC, eax
      INVOKE     SetTextColor, hDC, 00ff0000h
      INVOKE     SetBkMode, hDC, TRANSPARENT
         mov     eax, ImageID
      INVOKE     TextOut, hDC, 24, 4, addr szDrvLet[eax], 1
      INVOKE     ReleaseDC, hTB01, hDC
         .if HoldCnt > 0
               sub     HoldCnt, 1
               add     ImageID, 1
               add     XP, 35
               jmp     BuildLet
         .endif
         pop     HoldCnt
      .endif

GetOut:

ret_ok:
         mov     eax, TRUE
         ret

ret_error:
         xor     eax, eax   
         ret
ToolbarProc   ENDP

;=========================================================================|
; TreeViewNotify PROCEDURE                                                |
;=========================================================================|
TreeViewNotify proc uses ebx edx hWnd:DWORD, pnmtv:DWORD
;LOCAL    pshf:LPSHELLFOLDER
LOCAL    pshfw:LPSHELLFOLDER
LOCAL    pidl:LPITEMIDLIST
LOCAL    ptvobj:LPTV_OBJDATA
LOCAL    point:POINT
LOCAL    tvhti:TV_HITTESTINFO
LOCAL    tvi:TV_ITEM

         mov     eax, pnmtv
         mov     ebx,(NM_TREEVIEW ptr [eax]).itemNew.lParam 
         mov     ptvobj, ebx
         mov     eax, (NM_TREEVIEW ptr [eax]).hdr.code
         cmp     eax, TVN_ITEMEXPANDING
         je      ItemExpCol
         cmp     eax, TVN_SELCHANGEDA
         je      SelChanged
         cmp     eax, NM_RCLICK
         je      right_clicked

         jmp     ret_ok
      
;------------ [Folder is expanding or collapsing] ------------  
ItemExpCol:
         mov     ebx, pnmtv
        test     (NM_TREEVIEW ptr [ebx]).itemNew.state, TVIS_EXPANDEDONCE 
         jnz     ret_ok

         mov     ebx, ptvobj         
         mov     edx, (TV_OBJDATA ptr [ebx]).pshfParent
         mov     edx, [edx]
      INVOKE     (IShellFolder PTR [edx]).BindToObject, 
                 (TV_OBJDATA ptr [ebx]).pshfParent, 
                 (TV_OBJDATA ptr [ebx]).pidlRel, 0, addr IID_IShellFolder, addr pshf 
        test     eax,eax
         js      ret_error

         mov     ebx, pnmtv
         mov     edx, ptvobj

      INVOKE     UpdateTreeView, hWndTree, pshf, (TV_OBJDATA ptr [edx]).pidlFull, (NM_TREEVIEW ptr [ebx]).itemNew.hItem

      .if FirstSort
            mov     ebx, pnmtv
            mov     ebx,(NM_TREEVIEW ptr [ebx]).itemNew.hItem
         INVOKE     SendMessage, hWndTree, TVM_SORTCHILDREN, 0, ebx
      .endif
         or      FirstSort, 1

         mov     eax, pshf
         mov     eax, [eax]
      INVOKE     (IShellFolder ptr [eax]).Release, pshf
         jmp     ret_ok              
;------------ [Tree item selection has changed] ------------  
SelChanged:

      .if !Init
            jmp     FirstTime  ; If you remove this, uncomment the jz  ret_error below
      .endif

; Update list view header to give full path name

         mov     ebx, ptvobj
         mov     edx, (TV_OBJDATA ptr [ebx]).pidlFull
        push     edx
      INVOKE     SHGetPathFromIDList, edx, addr SavPath
        test     eax,eax
;         jz      ret_error ;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

         pop     edx
      INVOKE     SHGetFileInfo, edx, 0, addr sfi, sizeof SHFILEINFO,
                 SHGFI_PIDL or SHGFI_DISPLAYNAME
        test     eax,eax
         jz      ret_error
      INVOKE     lstrcpy, addr szWork, addr sfi.szDisplayName
      INVOKE     lstrlen, addr SavPath
      .if eax > 3 
         INVOKE     lstrcat, addr SavPath, addr szBackSL
      .endif
         mov     byte ptr szDrv+1, 0
      INVOKE     lstrcpyn, addr szDrv, addr SavPath, 4
      INVOKE     lstrcat, addr SavPath, addr szAllFiles

      INVOKE     lstrlen, addr szDrv
      .if eax != 0              ; Drives
            xor     edx, edx
            mov     dl, byte ptr szDrv
         .if edx < 91
               add     edx, 32  ; Change to lower case
         .endif
           push     edx        
         INVOKE     lstrlen, addr szDrvLet
            pop     edx
            mov     ecx, eax
            xor     eax, eax
         .while (ecx)
            .if dl == byte ptr szDrvLet[eax]
                  mov     ebx, eax
                  add     ebx, 200
                  jmp     Gotem
            .endif
               inc     eax
               dec     ecx
         .endw
            xor     ebx, ebx
      .endif
; Shaky but works should be redone
      .if szWork == 'C'
            mov     ebx, 100
      .elseif szWork == 'P'
            mov     ebx, 101
      .elseif szWork == 'S'
            mov     ebx, 102
      .elseif szWork == 'D'
            mov     ebx, 103
      .endif

      .if ebx
         INVOKE     ToolbarProc, hToolBarC, WM_CALLTOOLPROC, ebx, 0  ; Desk top
            jmp     ret_ok              
      .endif

Gotem:
        push     ebx
      INVOKE     lstrlen, addr SavPath
         pop     ebx
      .if eax < 7 
         INVOKE     ToolbarProc, hToolBarC, WM_CALLTOOLPROC, ebx, 0  ; Drives
            jmp     ret_ok              
      .endif

;INVOKE    MessageBox,NULL, offset SavPath, offset szTreeClassName, MB_OK

      INVOKE     SetButt, ebx
       MOVmd     ptvobj, Savptvobj
      INVOKE     GetDrvRoot, ptvobj
      .if SavList == 4
            mov     RestoreL, 000000ffh
      .else
            mov     RestoreR, 000000ffh
      .endif

NotDrv:
        call     GetHeader
      INVOKE     CopyData, SavList, ptvobj, pshf   ; Clears drive array & loads base ptvobj

      INVOKE     lstrlen, addr SavPath
         sub     eax, 2
      INVOKE     lstrcpyn, addr SavPath, addr SavPath, eax

      INVOKE     lstrlen, addr SavPath
         mov     ecx, eax
         lea     esi, SavPath
         xor     ecx, ecx
      .while (eax)
         .if byte ptr[esi] == '\'
               inc     ecx
         .endif
         dec     eax
         inc     esi
      .endw
         dec     ecx
      .if SavList == 4
            mov     LevCntL, ecx
      .else
            mov     LevCntR, ecx
      .endif

;------------ [Bind to that folder] ------------
      INVOKE     PathToPidl
      INVOKE     lstrcat, addr SavPath, addr szAllFiles

         mov     sw1, 4
         or      FromTree, 1
         mov     ebx, SavList
      INVOKE     UpdateListView, hWndList+[ebx], pidlBase, pshf
        test     eax,eax
         jz      ret_error
         mov     eax, pshf
         mov     eax, [eax]
      INVOKE     (IShellFolder ptr [eax]).Release, pshf
         and     FromTree, 0

      .if Init == 1
         INVOKE     UpdateSelBars
      .endif

FirstTime:
         or      Init, 1
         jmp     ret_ok              

;------------ [Right click use the context menu] ------------

right_clicked:
      INVOKE     GetCursorPos, addr point
      INVOKE     ScreenToClient, hWndTree, addr point
         mov     eax, point.x
         mov     tvhti.pt.x, eax
         mov     eax, point.y
         mov     tvhti.pt.y, eax
      INVOKE     SendMessage, hWndTree, TVM_HITTEST, 0, addr tvhti
      INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, tvhti.hItem
      .if (tvhti.flags & TVHT_ONITEM)
         INVOKE     ClientToScreen, hWndTree, addr point
            mov     tvi.imask, TVIF_HANDLE or TVIF_PARAM
            mov     eax, tvhti.hItem
            mov     tvi.hItem, eax
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, 0, addr tvi
           test     eax,eax
            jz      ret_error
            mov     ebx, tvi.lParam
            mov     ptvobj, ebx
         INVOKE     ContextMenu, hWnd, (TV_OBJDATA ptr [ebx]).pshfParent, (TV_OBJDATA ptr [ebx]).pidlRel, addr point
      .endif
         jmp     ret_ok
ret_ok:
         mov     eax, 1
         ret          
ret_error:
         xor     eax, eax   
         ret
TreeViewNotify endp

;=========================================================================|
; IDList_GetSize PROCEDURE                                                |
;=========================================================================|
IDList_GetSize proc uses ebx pidl:LPITEMIDLIST
LOCAL      cbTotal:DWORD
         mov     cbTotal, 0
      .if pidl != 0
            mov     ebx, pidl
start_loop:
          movsx     eax, (ITEMIDLIST PTR [ebx]).mkid.cb
           test     eax, eax
            jz      end_loop
            add     cbTotal, eax
            add     ebx, eax
            jmp     start_loop
end_loop:                                   
      .endif       
         mov     eax, cbTotal
;DSPValue hWndP, cbTotal, 1, 'm'
         ret
IDList_GetSize endp

;=========================================================================|
; IDList_CopyItem PROCEDURE                                                |
;=========================================================================|
IDList_CopyItem  proc uses ebx edx ecx edi esi pidl:LPITEMIDLIST
LOCAL      pidlNew:LPITEMIDLIST
LOCAL      w4:DWORD
      .if !pidl
            jmp     ret_null
      .endif
         mov     ebx, pidl 
       movsx     edx, (ITEMIDLIST PTR [ebx]).mkid.cb  ; D I E D from tree
         add     edx, sizeof WORD
         mov     w4, edx
         mov     edx, pShellMalloc
         mov     edx, [edx]
      INVOKE     (IMalloc PTR [edx]).Alloc, pShellMalloc, w4
        test     eax,eax
         jz      ret_null
         mov     pidlNew, eax
         mov     esi, pidl
         mov     edi, pidlNew
         mov     ecx, w4
      .WHILE     ecx != 0
            mov     al,byte ptr [esi]
            mov     byte ptr [edi], al       
            dec     ecx            
            inc     esi
            inc     edi
      .ENDW

ret_ok:
         mov     eax, pidlNew
         ret
ret_null:
         xor     eax,eax
         ret        
IDList_CopyItem  endp

;=========================================================================|
; IDList_Combine PROCEDURE                                                |
;=========================================================================|
IDList_Combine proc uses esi edi ecx edx pidl1:LPITEMIDLIST, pidl2:LPITEMIDLIST
LOCAL    pidlNew:LPITEMIDLIST
LOCAL    cb1:DWORD
LOCAL    cb2:DWORD
      
;----- [Get length of 1st pidl (not including NULL terminating word)] -----
      INVOKE     IDList_GetSize, pidl1
         mov     cb1, eax
      
;----- [Get length of 2nd pidl (not including NULL terminating word)] -----
      INVOKE     IDList_GetSize, pidl2
         mov     cb2, eax
      
;----- [Get total length of resulting combined pidl (including NULL terminating word)] -----
         mov     eax, sizeof ITEMIDLIST.mkid.cb
         add     eax, cb1
         add     eax, cb2  

;----- [Allocate the memory] -----
         mov     edx, pShellMalloc
         mov     edx,[edx]
      INVOKE     (IMalloc PTR [edx]).Alloc, pShellMalloc, eax
      
        test     eax,eax
         jz      ret_error
         mov     pidlNew, eax
      
;----- [Set destination] -----
         mov     edi, eax
      
;----- [Write 1st pidl to destination (pidlNew)] -----
         mov     esi, pidl1
         mov     ecx, cb1
      .WHILE ecx != 0
            mov     al, byte ptr [esi]
            mov     byte ptr [edi], al       
            dec     ecx            
            inc     esi
            inc     edi
      .ENDW             

;----- [Write 2nd pidl after 1st] -----
         mov     esi, pidl2
         mov     ecx, cb2
      .WHILE ecx != 0
            mov     al, byte ptr [esi]
            mov     byte ptr [edi], al       
            dec     ecx            
            inc     esi
            inc     edi
      .ENDW             
      
;----- [Add terminating word] -----
         mov     word ptr [edi], 0
         mov     eax, pidlNew
         ret

ret_error:
         xor     eax, eax
         ret        
IDList_Combine   endp

;=========================================================================|
; GetIcon PROCEDURE                                                       |
;=========================================================================|
; dwType = SHGFI_OPENICON or SHGFI_ICON
GetIcon proc uses edx pidl:LPITEMIDLIST, dwType:DWORD
LOCAL    shfi:SHFILEINFO
        
         mov     edx, SHGFI_PIDL or SHGFI_SYSICONINDEX or SHGFI_SMALLICON
         or      edx, dwType

;----- [SHGetfileinfo requires full pidl] -----
      INVOKE     SHGetFileInfo, pidl, 0, addr shfi, sizeof SHFILEINFO, edx
         mov     eax, shfi.iIcon
         mov     edx, shfi.hIcon
         mov     hIcon, edx
         mov     SavIcon, edx
         ret
GetIcon endp

;=========================================================================|
; SetButt PROCEDURE                                                       |
;=========================================================================|
SetButt proc  wParam:DWORD
      .if wParam > 99 && wParam < 104 || wParam > 199 && wParam < 226
         INVOKE     SendMessage, hToolBarC, TB_CHECKBUTTON, 100, FALSE
         INVOKE     SendMessage, hToolBarC, TB_CHECKBUTTON, 101, FALSE
         INVOKE     SendMessage, hToolBarC, TB_CHECKBUTTON, 102, FALSE
         INVOKE     SendMessage, hToolBarC, TB_CHECKBUTTON, 103, FALSE
         .if wParam > 199 && wParam < 226
               mov     eax, SavButtL
               sub     eax, 200
              imul     eax, 4
            INVOKE     SendMessage, hToolBar+[eax], TB_CHECKBUTTON, SavButtL, FALSE
               mov     eax, SavButtR
               sub     eax, 200
              imul     eax, 4
            INVOKE     SendMessage, hToolBar+[eax], TB_CHECKBUTTON, SavButtR, FALSE
         .endif
      .endif 

      .if wParam > 99 && wParam < 104
         INVOKE     SendMessage, hToolBarC, TB_CHECKBUTTON, wParam, TRUE
            mov     eax, wParam
            sub     eax, 100
           imul     eax, 4
          MOVmd     Savptvobj, ControlArray+[eax]
            ret
      .endif

      .if wParam > 199 && wParam < 226

; Restore the Drive Array in case it got clobbered, Looking for the cause.
            xor     ecx, ecx
            xor     eax, eax
         .while (ecx < 26)
             MOVmd     DriveArray[eax], SaveArray[eax]
               inc     eax
               inc     ecx
         .endw  

            mov     eax, wParam
            sub     eax, 200
           push     eax
         .if SavList == 8
             MOVmd     SavButtR, wParam
            INVOKE     SendMessage, hComboR, CB_SETCURSEL, eax, 0
         .else
             MOVmd     SavButtL, wParam
            INVOKE     SendMessage, hComboL, CB_SETCURSEL, eax, 0
         .endif
            pop     eax
           imul     eax, 4
            mov     edx, eax
          MOVmd     Savptvobj, DriveArray+[edx]
         INVOKE     SendMessage, hToolBar+[edx], TB_CHECKBUTTON, wParam, TRUE
      .endif
         ret
SetButt endp

;=========================================================================|
; Get drive name and tool tip PROCEDURE                                   |
;=========================================================================|
GetDrvRoot proc     ptvobj:LPTV_OBJDATA

         mov     ebx, ptvobj
         mov     edx, (TV_OBJDATA ptr [ebx]).pidlFull
      INVOKE     SHGetFileInfo, edx, 0, addr sfi, sizeof SHFILEINFO,
                 SHGFI_PIDL or SHGFI_DISPLAYNAME
        test     eax,eax
         jz      ret_error
      INVOKE     lstrcpy, addr szWork, addr sfi.szDisplayName
      INVOKE     lstrcpy, addr szToolTip, addr sfi.szDisplayName
         mov     eax, TRUE
ret_error:
         xor     eax, eax   
         ret
GetDrvRoot endp

;=========================================================================|
; Get Disk Space and set Header Title PROCEDURE                           |
;=========================================================================|
GetHeader proc
LOCAL    dw1:DWORD, dw2

         mov     szHeader, 0
      .if byte ptr szDrv+1 == 3ah  ; ':'
         INVOKE     GetVolumeInformation, addr szDrv, addr szVol, 20, 0, addr dw1, addr dw2, 0, 0
         INVOKE     lstrcpy, addr szHeader, addr szBL
         INVOKE     lstrcat, addr szHeader, addr szVol
         INVOKE     lstrcat, addr szHeader, addr szBR
         INVOKE     GetDiskFreeSpaceEx, addr szDrv, addr AvailQ, addr TotalQ, addr TFreeQ
          finit
            fld     OneK
           fild     AvailQ
           fdiv     ST(0), ST(1)
          fistp     AvailD
           fild     TotalQ
           fdiv     ST(0), ST(1)
          fistp     TotalD
         INVOKE     BaseAscii, AvailD, addr szAvail, 1, 10, 1, 1, 1
         INVOKE     BaseAscii, TotalD, addr szTotal, 16, 10, 1, 0, 1
         INVOKE     lstrcat, addr szHeader, addr szAvail
         INVOKE     lstrcat, addr szHeader, addr szOf
         INVOKE     lstrcat, addr szHeader, addr szTotal
         INVOKE     lstrcat, addr szHeader, addr szKFree
      .else
         INVOKE     lstrcpy, addr SavPath, addr szWork
      .endif

      .if SavList == 8
         INVOKE     lstrcpy, addr szPathR, addr SavPath
         INVOKE     lstrcpy, addr szTitleR, addr szHeader
         INVOKE     SetWindowText, hStatR, addr szTitleR
      .else
         INVOKE     lstrcpy, addr szPathL, addr SavPath
         INVOKE     lstrcpy, addr szTitleL, addr szHeader
         INVOKE     SetWindowText, hStatL, addr szTitleL
      .endif

         ret
GetHeader endp

;=========================================================================|
; Expand or Collapse Tree PROCEDURE                                       |
;=========================================================================|
ExpColTree proc uses ebx ecx edx Drive:DWORD, sw:DWORD

      .if (ViewFlags == 1) || (ViewFlags == 3) || !AutoTree
            jmp     ret_ok
      .endif

      .if Drive < 200 || hDrives == 0
            jmp     ret_ok
      .endif
         mov     eax, Drive
         sub     eax, 200
         mov     ebx, hDrives+[eax*4]
         mov     sw2, 12
        push     ebx   
      .if sw == 1
         INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, ebx
      .else
         INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_COLLAPSE or TVE_COLLAPSERESET, ebx
      .endif
         and     sw2, 0
         pop     ebx
      .if sw
         INVOKE     TreeBranch, ebx
      .endif

ret_ok:
         ret
ExpColTree endp

;=========================================================================|
; Expand Tree to proper branch converts a path to a tree handle PROCEDURE |
;=========================================================================|
TreeBranch proc uses ebx ecx edx esi hItem:DWORD
LOCAL    tvi:TV_ITEM
LOCAL    szPath[150]:byte
LOCAL    LevelCnt:DWORD, CntL:DWORD, dwState:DWORD

         mov     CntL, 0
      .if SavList == 4
         INVOKE     lstrcpy, addr szPath, addr szPathL+3
      .else
         INVOKE     lstrcpy, addr szPath, addr szPathR+3
      .endif
         cmp     byte ptr szPath, '*'
         je      ret_ok

      INVOKE     lstrlen, addr szPath
         sub     eax, 2
      INVOKE     lstrcpyn, addr szPath, addr szPath, eax
         lea     esi, szPath
         mov     LevelCnt, 1
      .while (byte ptr[esi]) != 0
         .if byte ptr[esi] == '\'
               add     LevelCnt, 1
         .endif
         inc     esi
      .endw

         xor     eax, eax
         lea     esi, szPath
      .while (byte ptr[esi]) != 0
         .if byte ptr[esi] == '\'
               inc     eax
            INVOKE     lstrcpyn, addr szBuff, addr szPath, eax
               inc     esi
            INVOKE     lstrcpy, addr szPath, esi
            .break
         .endif
         inc     eax
         inc     esi
      .endw

         mov     dwState, TVIS_BOLD
         xor     ebx, ebx

      .while (ebx < LevelCnt)
         .if byte ptr szPath == 0   ; Last level
               mov     dwState, TVIS_SELECTED or TVIS_BOLD
         .endif

;------------------- [First item of tree] -------------------
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CHILD, hItem
           test     eax, eax
            jz      ret_ok
            mov     hItem, eax
          MOVmd     tvi.hItem, hItem
            mov     tvi.imask, TVIF_TEXT
            lea     eax, szWork
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
         INVOKE     lstrcmpi, addr szWork, addr szBuff
         .if eax == 0
             MOVmd     tvi.hItem, hItem
               mov     tvi.imask, TVIF_STATE
             MOVmd     tvi.state, dwState ;TVIS_SELECTED
               mov     tvi.stateMask, 000000ffh
            INVOKE     SendMessage, hWndTree, TVM_SETITEM, NULL, addr tvi
            INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hItem
               jmp     NextLev
         .endif

;------------------- [Greater then first item of tree] -------------------
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_NEXT, hItem
         .while (eax != 0) 
               mov     hItem, eax
             MOVmd     tvi.hItem, hItem
               mov     tvi.imask, TVIF_TEXT
               lea     eax, szWork
               mov     tvi.pszText, eax
               mov     tvi.cchTextMax, 64
            INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
            INVOKE     lstrcmpi, addr szWork, addr szBuff
            .if eax == 0
                MOVmd     tvi.hItem, hItem
                  mov     tvi.imask, TVIF_STATE
                MOVmd     tvi.state, dwState ;TVIS_SELECTED
                  mov     tvi.stateMask, 000000ffh
               INVOKE     SendMessage, hWndTree, TVM_SETITEM, NULL, addr tvi
               INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hItem
               .break
            .endif
            INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_NEXT, hItem
         .endw

;------------------- [Get the path for the next level] -------------------
NextLev:
         .if byte ptr szPath == 0
               jmp     ret_ok
         .endif
            mov     szBuff, 0
            xor     eax, eax
            lea     esi, szPath
         .while (byte ptr[esi]) != 0
            .if byte ptr[esi] == '\'
                  inc     eax
               INVOKE     lstrcpyn, addr szBuff, addr szPath, eax
                  inc     esi
               INVOKE     lstrcpy, addr szPath, esi
               .break
            .endif
            inc     eax
            inc     esi
         .endw
         .if byte ptr szBuff == 0
               jmp     ret_ok
         .endif
            add     CntL, 1
            mov     ebx, CntL
      .endw

ret_ok:
         ret
TreeBranch endp

;=========================================================================|
; ContextMenu PROCEDURE                                                   |
;=========================================================================|
ContextMenu proc uses ebx edx hWnd:DWORD, pshfParent:LPSHELLFOLDER, pidl:LPITEMIDLIST, ppoint:DWORD
LOCAL    pcm    :LPCONTEXTMENU
LOCAL    hSMenu :DWORD
LOCAL    iCmd   :DWORD
LOCAL    cmi    :CMINVOKECOMMANDINFO
LOCAL    Cnt    :DWORD

         mov     ebx, pshfParent
         mov     ebx, [ebx]
      INVOKE     (IShellFolder ptr [ebx]).GetUIObjectOf, pshfParent,
                 hWnd, 1, addr pidl, addr IID_IContextMenu, 0, addr pcm
        test     eax,eax
         js      ret_error
      
      INVOKE     CreatePopupMenu
        test     eax,eax
         jz      ret_error
         mov     hSMenu, eax
         mov     ebx, pcm
         mov     ebx, [ebx]

      INVOKE     (IContextMenu ptr [ebx]).QueryContextMenu, pcm,
                 hSMenu, 0, 1, 7FFFh, CMF_EXPLORE or CMF_NORMAL ;or CMF_DEFAULTONLY ;or CMF_VERBSONLY
        test     eax,eax
         js      ret_error

      INVOKE     InsertMenu, hSMenu, 1, MF_BYPOSITION or MF_STRING, 65, addr szEdit

      INVOKE     GetMenuItemCount, hSMenu
         mov     Cnt, eax
      .while Cnt > 0
         INVOKE     GetMenuItemID, hSMenu, Cnt
         .if eax == 26
              add     Cnt, 1 
              jmp     GotCopy
         .endif
            sub     Cnt, 1
      .endw

GotCopy:
      INVOKE     InsertMenu, hSMenu, Cnt, MF_BYPOSITION or MF_STRING, 63, addr szPaste
         add     Cnt, 1
      INVOKE     InsertMenu, hSMenu, Cnt, MF_BYPOSITION or MF_STRING, 64, addr szRename
      .if HoldCmd == 25 || HoldCmd == 26
         INVOKE     EnableMenuItem, hSMenu, 63, MF_ENABLED
      .else
         INVOKE     EnableMenuItem, hSMenu, 63, MF_GRAYED
      .endif

         mov     edx, ppoint
      INVOKE     TrackPopupMenu, hSMenu, TPM_LEFTALIGN or TPM_RIGHTBUTTON or TPM_RETURNCMD,
                 (POINT ptr [edx]).x, (POINT ptr [edx]).y, 0, hWnd, 0
        test     eax,eax
         jz      ret_error
         mov     iCmd, eax
         mov     Cmd, eax
         mov     cmi.cbSize, sizeof CMINVOKECOMMANDINFO
         mov     cmi.fMask, 0
         mov     eax, hWnd
         mov     cmi.hwnd, eax
         mov     eax, iCmd
         dec     eax
         and     eax, 0000FFFFh
         mov     cmi.lpVerb, eax
         mov     cmi.lpParameters, 0
         mov     cmi.lpDirectory, 0
         mov     cmi.nShow, SW_SHOWNORMAL  ; or SW_HIDE
.if sw2 == 10
         mov     cmi.nShow, SW_HIDE
.endif
         mov     cmi.dwHotKey, 0
         mov     cmi.hIcon, 0
         mov     ebx, pcm
         mov     ebx, [ebx]
      INVOKE     (IContextMenu ptr [ebx]).InvokeCommand, pcm, addr cmi
      .if eax != 0 ; Failed non zero may not be a failure
            ; Send error message
      .endif

      INVOKE     DestroyMenu, hSMenu
      INVOKE     (IContextMenu ptr [ebx]).Release, pcm

ret_ok:
         mov     eax, 1
         ret
         
ret_error:
         xor     eax, eax
         ret
ContextMenu endp

END
;INVOKE    MessageBox,NULL, offset szTreeClassName, offset szTreeClassName, MB_OK
